//+------------------------------------------------------------------+
//|                                                  Ultra trend.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "copyleft mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 LimeGreen
#property indicator_color2 Red

//
//
//
//
//

extern int    Length          = 10;
extern int    Progression     = 8;
extern int    Sensitivity     = 30;
extern int    Price           = PRICE_CLOSE;
extern int    CountBars       = 500;
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsEmail     = false;

//
//
//
//
//

double buffer1[];
double buffer2[];
double trend[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(3);
   SetIndexBuffer(0,buffer1);
   SetIndexBuffer(1,buffer2);
   SetIndexBuffer(2,trend);
   return(0);
}

//
//
//
//
//

int start()
{
   int endLength    = Length + Progression * Sensitivity;            
   int counted_bars = IndicatorCounted();
   int i,limit;
   
   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
         limit = MathMin(Bars-counted_bars,MathMin(CountBars,Bars-1));

   //
   //
   //
   //
   //

   for (i=limit; i>=0; i--)
   {
      buffer1[i] = 0.00;
      buffer2[i] = 0.00;
      for (int k = Length; k <= endLength; k += Progression)
         if (iCustom(NULL,0,"JJMA",k,100,0,Price,i) > iCustom(NULL,0,"JJMA",k,100,0,Price,i+1))
              buffer1[i]++;
         else buffer2[i]++;
      trend[i] = trend[i+1];
         if (buffer1[i]>buffer2[i]) trend[i] =  1;
         if (buffer1[i]<buffer2[i]) trend[i] = -1;
   }
   manageAlerts();
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
            int forBar = 0;
      else      forBar = 1;
      if (trend[forBar]!=trend[forBar+1])
      {
         if (trend[forBar]== 1) doAlert(0,"up");
         if (trend[forBar]==-1) doAlert(0,"down");
      }            
   }
} 
void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message = Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" ultra trend to "+doWhat;
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," ultra trend"),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}

